local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

local IncDmg5sec = {}
local arrayIndex = 0
local tsIndex = 0
local myLastDamageTaken = time()
local CurrentTimestamp = 0
local event, sourceGUID, destGUID, destFlags, spellId, spellName, amount
local AoETargets = {}
local target_is_outsider = false
local source_is_outsider = false

x.CombatStart = 0

local regenRate
a.energyRegeneration = function()
	_, regenRate = GetPowerRegen()
	regenRate = format("%.2f", regenRate)
	return tonumber(regenRate)
end

local function clear()
	for i = 1, 5, 1 do
		IncDmg5sec[i] = 0
	end
end
clear()

a.COMBAT_LOG_EVENT_UNFILTERED = function (event, ...)
	CurrentTimestamp, event, _, sourceGUID, _, sourceFlags, _, destGUID, _, destFlags, _, spellId, spellName = ...
	myself = UnitGUID("player")
	tsIndex = mod(floor(CurrentTimestamp), 5) + 1
	target_is_outsider = bit.band(destFlags, COMBATLOG_OBJECT_AFFILIATION_OUTSIDER) > 0
	source_is_outsider = bit.band(sourceFlags, COMBATLOG_OBJECT_AFFILIATION_OUTSIDER) > 0
	
	if tsIndex > arrayIndex then
	-- the new index comes after the old index. we have to clear all array entries between them.
		for i = arrayIndex + 1, tsIndex, 1 do
			IncDmg5sec[i] = 0
		end
		arrayIndex = tsIndex
	elseif tsIndex < arrayIndex then
	-- the new index comes before the old index. we have to clear till the end of the array and then
	-- from the start up to the new index.
		for i = arrayIndex + 1, 5, 1 do
			IncDmg5sec[i] = 0
		end
		for i = 1, tsIndex, 1 do
			IncDmg5sec[i] = 0
		end
		arrayIndex = tsIndex
	end
	
	if destGUID == myself and string.find(event, "_DAMAGE") then
		myLastDamageTaken = CurrentTimestamp
		if destGUID == myself and (event == "SWING_DAMAGE") then
			amount = select(12, ...)
			IncDmg5sec[arrayIndex] = IncDmg5sec[arrayIndex] + amount
		else
			amount = select(15, ...)
			IncDmg5sec[arrayIndex] = IncDmg5sec[arrayIndex] + amount
		end
	end
	if sourceGUID == myself and destGUID ~= myself and target_is_outsider and (string.find(event, "_DAMAGE") or string.find(event, "_MISSED")) then
		AoETargets[destGUID] = CurrentTimestamp
	end
--	if sourceGUID ~= myself and destGUID == myself and source_is_outsider and (string.find(event, "_DAMAGE") or string.find(event, "_MISSED")) then
--		AoETargets[sourceGUID] = CurrentTimestamp
--	end
	if event == "UNIT_DIED" or event == "UNIT_DESTROYED" or event == "UNIT_DISSIPATES" then
		AoETargets[destGUID] = nil
	end
end

-- Check if we are in AoE mode
function a.ActiveEnemies()
	local now = time()
	local i = 0
	foreach(AoETargets, function(k, v)
		if v and now - v > 3 then
			AoETargets[k] = nil
		else
			i = i + 1
		end
	end)
	return i
end

a.leaveCombat = function()
	x.CombatStart = 0
end

a.enterCombat = function()
	x.CombatStart = GetTime()
end

-- register events
s.RegisterModuleEvent(AddonName, "PLAYER_REGEN_ENABLED", a.leaveCombat)
s.RegisterModuleEvent(AddonName, "PLAYER_REGEN_DISABLED", a.enterCombat)
s.RegisterModuleEvent(AddonName, "COMBAT_LOG_EVENT_UNFILTERED", a.COMBAT_LOG_EVENT_UNFILTERED)

function a.incomingDamage5s()
	local i
	local ret = 0
	for i = 1, 5, 1 do
		ret = ret + IncDmg5sec[i]
	end
	return ret
end

