local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()

	x.TimeToDie = s.TimeToDie("target") or 10
--	x.TimeToDie = 10
	x.InCombat = s.InCombat()
	x.GCD = s.GlobalCooldown() + x.Lag
	x.Spec = s.TalentMastery()
	x.FrenziedRegenerationShown = false;
--	x.ActiveEnemies = a.ActiveEnemies()
	x.MaxHealth = s.MaxHealth("player")
	x.Health = s.Health("player")
	x.ActiveEnemies = a.ActiveEnemies()
	x.Haste = 1 + UnitSpellHaste("player")/100
	x.MaxGCD = 1.5 / x.Haste
	if x.MaxGCD < 1 then
		x.MaxGCD = 1
	end

	if x.Spec == 1 then
		-- Balance

		x.MoonCharges = GetSpellCharges(202767--[[New Moon]])
		x.AstralPower = s.Power("player", SPELL_POWER_LUNAR_POWER )
		if s.Casting(190984--[[Solar Wrath]], "player") then
			x.AstralPower = x.AstralPower + 8
		end
		if s.Casting(194153--[[Lunar Strike]], "player") then
			x.AstralPower = x.AstralPower + 12
		end
		if s.Casting(202767--[[New Moon]], "player") then
			x.MoonCharges = x.MoonCharges - 1
			x.AstralPower = x.AstralPower + 10
		end
		if s.Casting(202768--[[Half Moon]], "player") then
			x.MoonCharges = x.MoonCharges - 1
			x.AstralPower = x.AstralPower + 20
		end
		if s.Casting(202771--[[Full Moon]], "player") then
			x.MoonCharges = x.MoonCharges - 1
			x.AstralPower = x.AstralPower + 40
		end
		x.AstralPowerDeficit = s.MaxPower("player", SPELL_POWER_LUNAR_POWER) - x.AstralPower
		x.MoonRechargeTime = max(s.SpellCooldown(202767--[[New Moon]]), s.SpellCooldown(202768--[[Half Moon]]), s.SpellCooldown(202771--[[Full Moon]]))
		x.TalentNaturesBalanceEnabled = s.HasTalent(202430--[[Nature's Balance]])
		x.BuffCelestialAlignmentRemains = s.MyBuffDuration(194223--[[Celestial Alignment]], "player")
		x.BuffCelestialAlignmentUp = x.BuffCelestialAlignmentRemains > x.Lag
		x.BuffIncarnationRemains = s.MyBuffDuration(102560--[[Incarnation: Chosen of Elune]], "player")
		x.BuffIncarnationUp = x.BuffIncarnationRemains > x.Lag

		a.Flash("stance,choose=moonkin_form")
		a.Flash("solar_beam") -- interrupt spellcasting

		if (x.ActiveEnemies >= 2 and s.HasTalent(202354--[[Stellar Drift]])) or x.ActiveEnemies >= 3 then
			a.Flash(--"potion,name=potion_of_prolonged_power,if=buff.celestial_alignment.up|buff.incarnation.up",
	--				"blessing_of_elune,if=active_enemies<=2&talent.blessing_of_the_ancients.enabled&buff.blessing_of_elune.down",
	--				"blessing_of_elune,if=active_enemies>=3&talent.blessing_of_the_ancients.enabled&buff.blessing_of_anshe.down",
	--				"blood_fury,if=buff.celestial_alignment.up|buff.incarnation.up",
	--				"berserking,if=buff.celestial_alignment.up|buff.incarnation.up",
	--				"arcane_torrent,if=buff.celestial_alignment.up|buff.incarnation.up",
	--				"use_items",
	--				"call_action_list,name=fury_of_elune,if=talent.fury_of_elune.enabled&cooldown.fury_of_elune.remains<target.time_to_die",
	--				"call_action_list,name=ed,if=equipped.the_emerald_dreamcatcher&active_enemies<=1",
					"new_moon,if=((charges=2&recharge_time<5)|charges=3)&astral_power.deficit>14",
					"half_moon,if=((charges=2&recharge_time<5)|charges=3|(target.time_to_die<15&charges=2))&astral_power.deficit>24",
					"full_moon,if=((charges=2&recharge_time<5)|charges=3|target.time_to_die<15)&astral_power.deficit>44",
	--				"stellar_flare,cycle_targets=1,max_cycle_targets=4,if=active_enemies<4&remains<7.2",
					"moonfire,cycle_targets=1,if=((talent.natures_balance.enabled&remains<3)|(remains<6.6&!talent.natures_balance.enabled))&astral_power.deficit>7",
					"sunfire,if=((talent.natures_balance.enabled&remains<3)|(remains<5.4&!talent.natures_balance.enabled))&astral_power.deficit>7",
	--				"astral_communion,if=astral_power.deficit>=71",
					"incarnation,if=astral_power>=40",
					"celestial_alignment,if=astral_power>=40",
	--				"starfall,if=buff.oneths_overconfidence.up&(!buff.solar_solstice.up|astral_power.deficit>44|buff.celestial_alignment.up|buff.incarnation.up)",
					"solar_wrath,if=buff.solar_empowerment.stack=3",
					"lunar_strike,if=buff.lunar_empowerment.stack=3",
	--				"starsurge,if=buff.oneths_intuition.up",
					"starfall,if=debuff.stellar_empowerment.remains<gcd.max*2|astral_power.deficit<22.5|(buff.celestial_alignment.remains>8|buff.incarnation.remains>8)|target.time_to_die<8",
					"new_moon,if=astral_power.deficit>14",
					"half_moon,if=astral_power.deficit>24",
					"full_moon,if=astral_power.deficit>44",
	--				"warrior_of_elune",
	--				"lunar_strike,if=buff.warrior_of_elune.up",
					"solar_wrath,if=buff.solar_empowerment.up",
					"lunar_strike,if=buff.lunar_empowerment.up",
	--				"moonfire,if=equipped.lady_and_the_child&active_enemies=2&spell_haste>0.4&!(buff.celestial_alignment.up|buff.incarnation.up)",
					"lunar_strike,if=active_enemies>=4|spell_haste<0.45",
					"solar_wrath")
		else
			a.Flash(--"potion,name=potion_of_prolonged_power,if=buff.celestial_alignment.up|buff.incarnation.up",
	--				"blessing_of_elune,if=active_enemies<=2&talent.blessing_of_the_ancients.enabled&buff.blessing_of_elune.down",
	--				"blessing_of_elune,if=active_enemies>=3&talent.blessing_of_the_ancients.enabled&buff.blessing_of_anshe.down",
	--				"blood_fury,if=buff.celestial_alignment.up|buff.incarnation.up",
	--				"berserking,if=buff.celestial_alignment.up|buff.incarnation.up",
	--				"arcane_torrent,if=buff.celestial_alignment.up|buff.incarnation.up",
	--				"use_items",
	--				"call_action_list,name=fury_of_elune,if=talent.fury_of_elune.enabled&cooldown.fury_of_elune.remains<target.time_to_die",
	--				"call_action_list,name=ed,if=equipped.the_emerald_dreamcatcher&active_enemies<=1",
					"new_moon,if=((charges=2&recharge_time<5)|charges=3)&astral_power.deficit>14",
					"half_moon,if=((charges=2&recharge_time<5)|charges=3|(target.time_to_die<15&charges=2))&astral_power.deficit>24",
					"full_moon,if=((charges=2&recharge_time<5)|charges=3|target.time_to_die<15)&astral_power.deficit>44",
	--				"stellar_flare,cycle_targets=1,max_cycle_targets=4,if=active_enemies<4&remains<7.2",
					"moonfire,cycle_targets=1,if=((talent.natures_balance.enabled&remains<3)|(remains<6.6&!talent.natures_balance.enabled))&astral_power.deficit>7",
					"sunfire,if=((talent.natures_balance.enabled&remains<3)|(remains<5.4&!talent.natures_balance.enabled))&astral_power.deficit>7",
	--				"astral_communion,if=astral_power.deficit>=71",
					"incarnation,if=astral_power>=40",
					"celestial_alignment,if=astral_power>=40",
	--				"starfall,if=buff.oneths_overconfidence.up&(!buff.solar_solstice.up|astral_power.deficit>44|buff.celestial_alignment.up|buff.incarnation.up)",
					"solar_wrath,if=buff.solar_empowerment.stack=3",
					"lunar_strike,if=buff.lunar_empowerment.stack=3",
	--				"starsurge,if=buff.oneths_intuition.up",
					"starsurge,if=astral_power.deficit<44|(buff.celestial_alignment.up|buff.incarnation.up|buff.astral_acceleration.remains>5|(set_bonus.tier21_4pc&!buff.solar_solstice.up))|(gcd.max*(astral_power%40))>target.time_to_die",
					"new_moon,if=astral_power.deficit>14&!(buff.celestial_alignment.up|buff.incarnation.up)",
					"half_moon,if=astral_power.deficit>24&!(buff.celestial_alignment.up|buff.incarnation.up)",
					"full_moon,if=astral_power.deficit>44",
	--				"warrior_of_elune",
	--				"lunar_strike,if=buff.warrior_of_elune.up",
					"solar_wrath,if=buff.solar_empowerment.up",
					"lunar_strike,if=buff.lunar_empowerment.up",
					"solar_wrath")
		end
	elseif x.Spec == 2 then
		-- Feral
		x.Energy = s.Power("player", SPELL_POWER_ENERGY )
		x.MaxEnergy = s.MaxPower("player", SPELL_POWER_ENERGY)
		x.EnergyDeficit = x.MaxEnergy - x.Energy
		x.EnergyRegen = a.energyRegeneration()
		x.CP = s.Power("player", SPELL_POWER_COMBO_POINTS)
		x.DotRipRemains = s.MyDebuffDuration(1079--[[Rip]], "target")
		x.DotRakeRemains = s.MyDebuffDuration(1822--[[Rake]], "target")
		x.TalentBloodtalonsEnabled = s.HasTalent(155672--[[Bloodtalons]])
		x.TalentLunarInspirationEnabled = s.HasTalent(155580--[[Lunar Inspiration]])
		x.TalentSabertoothEnabled = s.HasTalent(202031--[[Sabertooth]])
		x.BuffPredatorySwiftnessUp = s.BuffDuration(69369--[[Predatory Swiftness]], "player") > x.GCD
		x.BuffBloodtalonsDown = s.BuffDuration(145152--[[Bloodtalons]], "player") <= x.GCD
		x.BuffBloodtalonsUp = s.BuffDuration(145152--[[Bloodtalons]], "player") > x.GCD
		x.BuffIncarnationUp = s.BuffDuration(102543--[[Incarnation]], "player") > x.GCD
		x.BuffClearcastingUp = s.BuffDuration(135700--[[Clearcasting]], "player") > x.GCD
		x.HalvedCost = s.BuffDuration({106951--[[Berserk]], 102543--[[Incarnation]]}, "player") > x.GCD


		x.RakeCost = s.If(x.HalvedCost, 18, 35)
		x.ShredCost = s.If(x.BuffClearcastingUp, 0, s.If(x.HalvedCost, 20, 40))
		x.MoonfireCost = s.If(x.HalvedCost, 15, 30)
		x.ThrashCost = s.If(x.BuffClearcastingUp, 0, s.If(x.HalvedCost, 23, 45))
		x.BrutalSlashCost = s.If(x.BuffClearcastingUp, 0, s.If(x.HalvedCost, 10, 20))
		x.SwipeCost = s.If(x.BuffClearcastingUp, 0, s.If(x.HalvedCost, 20, 40))
		x.RipCost = s.If(x.HalvedCost, 15, 30)
		x.BiteCost = s.If(x.HalvedCost, 13, 25)

		x.UseThrash = 0

		a.Flash("cat_form,if=!buff.cat_form.up")
		a.Flash("skull_bash")

		if (GetTime() - x.CombatStart) <= 15 and x.RipDuration == 0 and s.Boss("target") then
			-- Opener
			a.Flash("rake,if=!ticking|buff.prowl.up"
					,"dash,if=!buff.cat_form.up"
					,"auto_attack"
					,"moonfire_cat,if=talent.lunar_inspiration.enabled&!ticking"
					,"savage_roar,if=!buff.savage_roar.up"
					,"berserk"
					,"incarnation"
					,"tigers_fury"
					,"ashamanes_frenzy"
					,"regrowth,if=(talent.sabertooth.enabled|buff.predatory_swiftness.up)&talent.bloodtalons.enabled&buff.bloodtalons.down&combo_points=5"
					,"rip,if=combo_points=5"
					,"thrash_cat,if=!ticking&variable.use_thrash>0"
					,"shred")
		else
			-- Single Target
			a.Flash("rake,if=buff.prowl.up|buff.shadowmeld.up"
					,"auto_attack"
					-- Cooldowns
					,"dash,if=!buff.cat_form.up"
					,"prowl,if=buff.incarnation.remains<0.5&buff.jungle_stalker.up"
					,"berserk,if=energy>=30&(cooldown.tigers_fury.remains>5|buff.tigers_fury.up)"
					,"tigers_fury,if=energy.deficit>=60"
--					,"berserking"
					,"elunes_guidance,if=combo_points=0&energy>=50"
					,"incarnation,if=energy>=30&(cooldown.tigers_fury.remains>15|buff.tigers_fury.up)"
--					,"potion,name=prolonged_power,if=target.time_to_die<65|(time_to_die<180&(buff.berserk.up|buff.incarnation.up))"
					,"ashamanes_frenzy,if=combo_points>=2&(!talent.bloodtalons.enabled|buff.bloodtalons.up)"
--					,"shadowmeld,if=combo_points<5&energy>=action.rake.cost&dot.rake.pmultiplier<2.1&buff.tigers_fury.up&(buff.bloodtalons.up|!talent.bloodtalons.enabled)&(!talent.incarnation.enabled|cooldown.incarnation.remains>18)&!buff.incarnation.up"
--					,"use_items"

					,"ferocious_bite,target_if=dot.rip.ticking&dot.rip.remains<3&target.time_to_die>10&(target.health.pct<25|talent.sabertooth.enabled)"
					,"regrowth,if=combo_points=5&buff.predatory_swiftness.up&talent.bloodtalons.enabled&buff.bloodtalons.down&(!buff.incarnation.up|dot.rip.remains<8)"
					,"regrowth,if=combo_points>3&talent.bloodtalons.enabled&buff.predatory_swiftness.up&buff.apex_predator.up&buff.incarnation.down"
					,"ferocious_bite,if=buff.apex_predator.up&((combo_points>4&(buff.incarnation.up|talent.moment_of_clarity.enabled))|(talent.bloodtalons.enabled&buff.bloodtalons.up&combo_points>3))"

					-- Single Target Finishers
--					,"pool_resource,for_next=1"
					,"savage_roar,if=buff.savage_roar.down"
--					,"pool_resource,for_next=1"
					,"rip,target_if=!ticking|(remains<=duration*0.3)&(target.health.pct>25&!talent.sabertooth.enabled)|(remains<=duration*0.8&persistent_multiplier>dot.rip.pmultiplier)&target.time_to_die>8"
--					,"pool_resource,for_next=1"
					,"savage_roar,if=buff.savage_roar.remains<12"
--					,"maim,if=buff.fiery_red_maimers.up"
					,"ferocious_bite,max_energy=1"

					-- Generators
					,"regrowth,if=talent.bloodtalons.enabled&buff.predatory_swiftness.up&buff.bloodtalons.down&combo_points>=2&cooldown.ashamanes_frenzy.remains<gcd"
					,"regrowth,if=talent.bloodtalons.enabled&buff.predatory_swiftness.up&buff.bloodtalons.down&combo_points=4&dot.rake.remains<4"
--					,"regrowth,if=equipped.ailuro_pouncers&talent.bloodtalons.enabled&(buff.predatory_swiftness.stack>2|(buff.predatory_swiftness.stack>1&dot.rake.remains<3))&buff.bloodtalons.down"
					,"brutal_slash,if=spell_targets.brutal_slash>desired_targets"
--					,"pool_resource,for_next=1"
					,"thrash_cat,if=refreshable&(spell_targets.thrash_cat>2)"
--					,"pool_resource,for_next=1"
--					,"thrash_cat,if=spell_targets.thrash_cat>3&equipped.luffa_wrappings&talent.brutal_slash.enabled"
--					,"pool_resource,for_next=1"
					,"rake,target_if=!ticking|(!talent.bloodtalons.enabled&remains<duration*0.3)&target.time_to_die>4"
--					,"pool_resource,for_next=1"
					,"rake,target_if=talent.bloodtalons.enabled&buff.bloodtalons.up&((remains<=7)&persistent_multiplier>dot.rake.pmultiplier*0.85)&target.time_to_die>4"
--					,"brutal_slash,if=(buff.tigers_fury.up&(raid_event.adds.in>(1+max_charges-charges_fractional)*recharge_time))"
					,"moonfire_cat,target_if=refreshable"
--					,"pool_resource,for_next=1"
					,"thrash_cat,if=refreshable&(variable.use_thrash=2|spell_targets.thrash_cat>1)"
--					,"thrash_cat,if=refreshable&variable.use_thrash=1&buff.clearcasting.react"
--					,"pool_resource,for_next=1"
					,"swipe_cat,if=spell_targets.swipe_cat>1"
					,"shred,if=dot.rake.remains>(action.shred.cost+action.rake.cost-energy)%energy.regen|buff.clearcasting.react")
		end



	elseif x.Spec == 3 then
		-- Guardian
		x.Rage = s.Power("player", SPELL_POWER_RAGE )
		x.MaxRage = s.MaxPower("player", SPELL_POWER_RAGE)
		x.BuffIronfurUp = (s.BuffDuration(192081--[[Ironfur]], "player", nil, false, false, true) > x.Lag)
		x.BuffIncarnationUp = (s.BuffDuration(102558--[[Incarnation: Guardian of Ursoc]], "player", nil, false, false, true) > x.Lag)
		x.BuffGalacticGuardianUp = (s.BuffDuration(213708--[[Galactic Guardian]], "player", nil, false, false, true) > x.GCD)
		x.DotMoonfireRemains = s.DebuffDuration(8921--[[Moonfire]], "target")
		a.Flash("stance,choose=bear_form")
		a.Flash("Wild Charge") -- if we are not in range, use these
		a.Flash("skull_bash") -- interrupt spellcasting
		a.Flash("Growl") -- taunt if tanking and not keeping aggro
--		if not x.InCombat and x.EnemyDetected then
--			a.FlashAll("flask,type=greater_draenic_stamina_flask",
--					   "potion,name=draenic_agility")
--		end
--		x.IncomingDamage6s = a.incomingDamage6sec()
		x.Stop = false
		a.Flash("auto_attack",
--				"blood_fury",
--				"berserking",
--				"arcane_torrent",
--				"use_item,slot=trinket2",
				"incarnation",
				"rage_of_the_sleeper",
--				"lunar_beam",
				"frenzied_regeneration,if=incoming_damage_5s%health.max>=0.5|health<=health.max*0.4",
--				"bristling_fur,if=buff.ironfur.stack=1|buff.ironfur.down",
				"ironfur,if=(buff.ironfur.up=0)|(buff.gory_fur.up=1)|(rage>=80)",
				"moonfire,if=buff.incarnation.up=1&dot.moonfire.remains<=4.8",
				"thrash_bear,if=buff.incarnation.up=1&dot.thrash.remains<=4.5",
				"mangle",
				"thrash_bear",
--				"pulverize,if=buff.pulverize.up=0|buff.pulverize.remains<=6",
				"moonfire,if=buff.galactic_guardian.up=1&(!ticking|dot.moonfire.remains<=4.8)",
				"moonfire,if=buff.galactic_guardian.up=1",
				"moonfire,if=dot.moonfire.remains<=4.8",
				"swipe_bear")
	end
end)
